(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)

open S3
open Printf
open Prins

let _ = 
  let alice = {id="alice"; cert="alice"; ip="127.0.0.1"; port=8001} in
  let bob = {id="bob"; cert="bob"; ip="127.0.0.1"; port=8002} in
  let charlie = {id="charlie"; cert="charlie"; ip="127.0.0.1"; port=8003} in
    register alice; register bob; register charlie

type choiceOnOffer = UChange of string | UAccept
let offer_ui offer =
  if offer = "Redmond, 8am-9am"
  then UChange "Cambridge" else UAccept

let _ =
  let (prins:principals) = { 
    customer = "alice"; 
    officer = "charlie";
    store = "bob"; } in
  let r = "12 March 2007" in
  let rec msg1 = { 
      hReject = (fun _ s -> printf "%s\n" s;Abort((),()));
      hOffer = (fun _ offer -> 
        match offer_ui offer with
          | UChange location -> Change(location,msg1)
          | UAccept -> Accept((),()))} in
  let msg0 = Request(r,msg1) in
  let worker () = 
    customer prins msg0;
    printf "Customer: session complete.\n\n" in
  worker()
 
