(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)

using System;
using System.Collections.Generic;
using System.Threading;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ClientUI
{
    public partial class Form1 : Form, Example3u.GUI0
    {
        private AutoResetEvent ready = new AutoResetEvent(false);
        AutoResetEvent Example3u.GUI0.GetReady()
        {
            return ready;
        }
        private Example3u.ChoiceOnOffer coc = null;
        private string current_offer = "";
        void Example3u.GUI0.Offer_event(string offer)
        {
            Status.Text = "Received an offer.";
            current_offer = offer;
            Offer.Text = current_offer;
            OfferLabel.Visible = true;
            Offer.Visible = true;
            Accept.Visible = true;
            Accept.Enabled = true;
            Offer.Enabled = true;
        }
        Example3u.ChoiceOnOffer Example3u.GUI0.Offer_result()
        {
            return coc;
        }
        void Example3u.GUI0.Reject_event()
        {
            Status.Text = "Failed! The store declined.";
        }
        public Form1()
        {
            InitializeComponent();
            RequestArg.Select();
        }
        
        private void Request_Click(object sender, EventArgs e)
        {
            Request.Enabled = false;
            OfficeText.ReadOnly = true;
            StoreText.ReadOnly = true;
            RequestArg.Enabled = false;
            S3.principals party = new S3.principals(ClientText.Text,
                OfficeText.Text, StoreText.Text);
            Example3u.Start_customer(this, this, party, RequestArg.Text);
            Status.Text = "Sent initial request.";
        }

        private void Confirm_Click(object sender, EventArgs e)
        {
            // accepting
            Accept.Enabled = false;
            Offer.Enabled = false;
            coc = Example3u.ChoiceOnOffer.UAccept;
            Status.Text = "Done! " 
                + RequestArg.Text + ", " + current_offer + ".";
            ready.Set();
        }

        private void Offer_Change(object sender, EventArgs e)
        {
            // changing
            if (Offer.Text != current_offer)
            {
                Accept.Enabled = false;
                Offer.Enabled = false;
                coc = Example3u.ChoiceOnOffer.UChange(Offer.Text);
                Status.Text = "Sent change of location.";
                ready.Set();
            }
        }
        private void Status_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }
     }
}