(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)

open S3
open Printf
open Prins

let _ = 
  let alice = {id="alice"; cert="alice"; ip="127.0.0.1"; port=8666} in
  let bob = {id="bob"; cert="bob.pub"; ip="127.0.0.1"; port=8002} in
  let charlie = {id="charlie"; cert="charlie"; ip="127.0.0.1"; port=8666} in
    register alice; register bob; register charlie

let offer loc = List.assoc loc 
  [ "Default", "Redmond, 8am-9am";  
    "Redmond", "Redmond, 3pm-4pm";
    "Orsay", "Orsay, lunchtime";
    "Cambridge", "Cambridge, 6pm-7pm" ] 

let server prins req = 
  printf "Server: session starting for %s.\n" req;
  let rec new_offer prins (loc:string) = 
  try
    let o = offer loc in
    Offer(o, {
      hChange = new_offer;
      hAccept = (fun _ () -> Confirm((),"in "^o)); })
  with _ -> Reject("no","no offer available") in
  new_offer prins "Default"

let _ = 
  let status = store "bob" { hContract = server; } in
  printf "Store: Done! %s.\n" status
