(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)

type str =
    | Literal of string
    | Base64 of bytes
        
and bytes = 
    | Concat of bytes * bytes
    | Utf8 of str
    | Bin of blob

and blob = 
    | Hash of bytes
    | Nonce of bytes
    | AsymSign of bytes * bytes
    | AsymEncrypt of bytes * bytes

val base64 : bytes -> str
val ibase64 : str -> bytes
val utf8 : str -> bytes
val iutf8 : bytes -> str
val concat : bytes -> bytes -> bytes
val iconcat : bytes -> bytes * bytes
val concat3 : bytes -> bytes -> bytes -> bytes
val iconcat3 : bytes -> bytes * bytes * bytes
val cS : string -> str
val iS : str -> string
val spstr: str -> string
val spbytes: bytes -> string 

