(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)

open Global
open Data

(* let cacheDb : (string * ()) list ref = ref []  *)

type pr = {id:string; cert:string; ip:string; port:int}

let register (prin:pr) =
  Pi.create_chan prin.id

let precv (self:string) =
  let text = Pi.recv self in
  debug "Prins" ("received:\n"^(spstr text)) ;
  text

let psend (dest:string) (text:str): unit = 
  debug "Prins" ("sent to "^dest^":\n"^(spstr text)) ;
  Pi.send dest text


let get_privkey s = utf8 (cS ((iS s)^".key"))
let get_pubkey s = utf8 (cS ((iS s)^".pub"))


let bind (self:string) = 
  ()

let close () = 
  ()

let check_cache (prin:string) (role:int) (sid:bytes) = 
  let rec read_lines chan =
    let s = 
      try Some (input_line chan) with
          End_of_file -> None in
    match s with
        Some m -> (m)::(read_lines chan)
      | None -> [] in 
  let f = Unix.openfile (prin^(string_of_int role)^".cache") [Unix.O_RDWR; Unix.O_CREAT] 0o640 in
  let ch = Unix.in_channel_of_descr f in
  let l = read_lines ch in
  if List.mem (spstr (base64 sid)) l 
  then (
      Unix.close f;
      failwith "cache error" )
  else (
    debug "Prins" ("Adding "^(spstr (base64 sid))) ;
    let sid_string = (spstr (base64 sid))^"\n" in
    let _ = Unix.write f sid_string 0 (String.length sid_string) in
    Unix.close f)










