(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)

(********************************************************************)
(* Session - Implementation                                         *)
(*                                                                  *)
(* dotgen.ml                                                        *)
(********************************************************************)


(* Given a graph and a session, we want to output a corresponding dot file *)

open Syntax
open Graph
open Printf


let gen_dot (filename:string) (g:graph) (ra:assoc) =

  let f = open_out filename in
  output_string f ("digraph G {\n  rankdir=LR;\n  \nsize=\"6,2\";  fontsize=20;\n\n") ;
  List.iter (function (i,(m,_),j) ->       
    output_string f (sprintf "  %i -> %i [label=\"%s\"];\n" i j m);
    
    output_string f (sprintf "  %i [label=\"%s\"];\n" j (List.assoc j ra)) ;
    if i = 0 then
      output_string f (sprintf "  %i [label=\"%s\",peripheries=2];\n  {rank = min; 0;}\n" i (List.assoc i ra))
    else 
      output_string f (sprintf "  %i [label=\"%s\"];\n" i (List.assoc i ra))) g ;
  output_string f ("}\n") ;
  close_out f

