(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)

(********************************************************************)
(* Session - Implementation                                         *)
(*                                                                  *)
(* generation.ml                                                    *)
(********************************************************************)
(* $Id: generation.ml 2895 2007-06-26 11:19:41Z denielou $ *)

(*#use "c:/Documents and Settings/t-ricarc/inria-msr-sec/lang-sec/session-types/src/syntax.ml";;*)
(*#use "/Users/ricardocorin/inria-msr-sec/lang-sec/session-types/src/syntax.ml";;*)

open Syntax 
open Mlsyntax
open Graph

let debug = Common.debug Common.debug_g "gen"

(********************************************)
(*             Library Part                 *)
(********************************************)

(*let lib_functions = 
  "let make_principals (principals_list:string list) (nb_parties:int)= \n"^
    "  let rec icc p acc = \n"^
    "  match p with \n"^
    "    | [] -> acc\n"^
    "    | a::rest -> let newacc = concat acc (utf8 (S a)) in icc rest newacc in\n"^
    "  let start = utf8 (S (List.hd principals_list)) in\n"^
    "  icc (List.tl principals_list) start\n"^
    "let get_principals  (principals:bytes) = \n"^
    "  let rec rev = function [] -> [] | a::l -> (rev l)@[a] in\n"^
    "  let rec icc p count = \n"^
    "    if count=1 then \n"^
    "       [iS (iutf8 p)]\n"^
    "    else \n"^
    "      let (a,rest) = iconcat p in\n"^
    "      let ab = iS (iutf8 rest) in\n"^
    "	ab::(icc a (count-1)) in\n"^
    "   rev(icc principals nb_parties)\n"^
    "let rec populate_emptysigs (nb_parties:int) = \n"^
    "  let rec icc count = \n"^
    "    if count=1 then \n"^
    "      [utf8 (cS \"\")]\n"^
    "    else \n"^
    "      let ab = (utf8 (cS \"\")) in\n"^
    "       ab::(icc (count-1)) in\n"^
    "    icc nb_parties\n\n"^
    "let rec update_signature (last_sig:bytes list) (role:int) (newsig:bytes) =\n"^
    "  if role = 0 then (newsig::(List.tl last_sig)) else (List.hd last_sig)::update_signature (List.tl last_sig) (role-1) newsig\n\n"^
    "let make_signature (principal:string) (label:string) (sid:bytes) (time:int) : bytes = \n"^
    "  let signk = Prins.get_privkey (cS principal) in\n"^
    "  let msg = concat3 sid (utf8 (cS label)) (utf8 (cS (string_of_int time))) in\n"^
    "  rsa_sign signk msg\n\n"^
    "let check_signature (principal:string) (label:string) (sid:bytes) (time:int) (signature:bytes) (last_sig:bytes list) (role:int) : unit = \n"^
    "  let pubk = Prins.get_pubkey (cS principal) in\n"^
    "  let msg = concat3 sid (utf8 (cS label)) (utf8 (cS (string_of_int time))) in\n"^
    "    rsa_verify pubk msg signature\n\n"^
    "let receive_label prin_list sid (role:int) (label:string) (msg:bytes) (last_sig:bytes list) (localtime:int) (vision: (int * string) list) = \n"^
    "let principal = List.nth prin_list role in\n"^
    "let check_visible  ((time:int), (rest:bytes))((role:int) , (label:string)): (int * bytes) =\n"^
    "    let bt',sv,rest = iconcat3 rest in\n"^
    "    let t' = int_of_string (iS (iutf8 bt')) in\n"^
    "      let principal = List.nth prin_list role in\n"^
    "        check_signature principal label sid t' sv last_sig role;\n"^
    " 	(t',rest) in\n"^
    "  let update_sigs ((last_sig:bytes list),(rest:bytes)) ((role:int) , (label:string))  = \n"^
    "       let bt',sv,rest = iconcat3 rest in\n"^
    "       ((update_signature last_sig role sv),rest) in\n"^
    "  let (new_localtime,rest) = (List.fold_left check_visible (localtime,msg) vision) in \n"^
    "  let (new_Lastsig,rest) = (List.fold_left update_sigs (last_sig,msg) vision) in \n"^
    "    new_Lastsig\n\n"^
    "let send_label prin_list sid (role:int) (dest:int) (label:string) (last_sig:bytes list) (localtime:int) (vision: (int * string) list) = \n"^
    "  let principal = List.nth prin_list role in\n"^
    "  let fetch_signature  (rest:bytes) ((role:int) , (label:string)):  bytes =\n"^
    "    (*Printf.printf \"forwarding signature from role %d, label %s\\n\" role label; *)\n"^ 
    "    concat3 (utf8 (cS (string_of_int localtime))) (List.nth last_sig role) rest in\n"^
    "  let l = if List.length vision > 1 then List.tl vision else vision in\n"^
    "  let msg = (List.fold_left fetch_signature (utf8 (cS \"\"))) l in \n"^
    "  let localsig = make_signature principal label sid localtime in\n"^
    "  let newLast_sig = update_signature last_sig role localsig in\n"^
    "  (newLast_sig, concat3 (utf8 (cS (string_of_int localtime))) localsig msg)\n\n"^
    "let hashed_info session_hashed (nonce:bytes) prin_list = "^
    "  Crypto.sha1 (concat3 session_hashed (make_principals prin_list nb_parties) nonce)\n\n"^
    "let receiveMsg (host:int) (prin_list: principals_list) r_sid vision = \n"^
    "  let principal = List.nth prin_list host in\n"^
    "  let (_,localport) = Prins.get_address (!addrDb) principal in\n"^
    "  let s = Net.recv_udp localport  in\n"^
    "  let (msg, sigs) = iconcat (ibase64 s) in\n"^
    "  let (header,payload) = iconcat (msg) in\n"^
    "  let (host2, dest2, sid) = iconcat3 header in\n"^
    "  assert (r_sid = sid);\n"^
    "  let (raw_tag,iN) = iconcat payload in\n"^
    "  let tag = (iS (iutf8 raw_tag)) in\n"^
    "  (tag, int_of_string (iS (iutf8 host2)), int_of_string (iS (iutf8 dest2)), sid, payload)\n\n"^
    "let receiveMsg_init (host:int) (prin:principal) session_hashed vision = \n"^
    "  let (_,localport) = Prins.get_address (!addrDb) prin in\n"^
    "  let s = Net.recv_udp localport  in\n"^
    "  let (msg, sigs) = iconcat (ibase64 s) in\n"^
    "  let (header,payload) = iconcat (msg) in\n"^
    "  let (host2, dest2, sid) = iconcat3 header in\n"^
    "  let (session_hashed, principals_list, nonce) = iconcat3 sid in\n"^
    "  let prin_list = get_principals principals_list in\n"^
    "  if sha1 sid <> (hashed_info session nonce prin_list)\n"^
    "  then failwith \"wrong expected session\"\n"^
    "  else\n"^
    "    let (raw_tag,iN) = iconcat payload in\n"^
    "    let tag = (iS (iutf8 raw_tag)) in\n"^
    "    (tag, int_of_string (iS (iutf8 host2)), int_of_string (iS (iutf8 dest2)), sid, payload)\n\n"^
    "let sendMsg (host:int) (dest:int) (prin_list: principals_list) sid header payload newLast_sig sigs =\n"^
    "  let msg = concat header payload in\n"^
    "  let plaintext =  concat msg sigs in\n"^
    "  let principal =   List.nth prin_list host in\n"^
    "  let (_,localport) = Prins.get_address (!addrDb) principal in\n"^
    "  let destprin = List.nth prin_list dest in\n"^
    "  let (destUrl, destPort) =  Prins.get_address (!addrDb) destprin in\n"^
    "  let _ = Net.send_udp (localport+50) destUrl destPort (base64 plaintext) principal in
      newLast_sig\n"
*)
(********************************************)
(*             Initial Part                 *)
(********************************************)

let beginning = 
  "open Global\nopen Base64\nopen Data\n"
  ^"open Crypto\n"
  ^"open Prins\n" 

let rec print_graph (g:graph) = 
  match g with
      [] -> ""
    | ((n1,(c,p),n2)::rest) -> 
        (Printf.sprintf "(%d,(%s,%s),%d)" n1 c p n2)^(print_graph rest)

let global_def (g:graph) (c:int) =
  beginning
  ^"let session = sha1 (utf8 (cS\""
  ^(print_graph g)
  ^"\"))\nlet nb_parties = "^(string_of_int c)^"\n"
(*  ^"\n\nlet hashed_info (nonce:bytes) prin_list = "
  ^"Crypto.sha1 (concat3 session (make_principals prin_list) nonce)\n\n\n"
*)


(********************************************)
(*              Wired Part                  *)
(********************************************)

let gen_wired_type (i:node) = Printf.sprintf "wired%i" i
let gen_wired_type_init_recv (i:node) = Printf.sprintf "(principals_list * wired%i)" i
let gen_wired_cons s = Printf.sprintf "Wired%s" s

let crypto_params_receive = "(origin:int) (host:int) (st:state)"
let crypto_params_send = " (host:int) (dest:int)"
let gen_wired_fun_receive (i:node) = Printf.sprintf "receiveWired%i %s" i crypto_params_receive
let gen_wired_fun_send (cons:string) = Printf.sprintf "sendWired%s %s" cons crypto_params_send

let crypto_params_receive_init = "(origin:int) (host:int)  (prin: principal) "
(*let crypto_params_send_init = " (host:int) (dest:int) (prin_list: string list) nonce"*)
let gen_wired_fun_receive_init (i:node) = Printf.sprintf "receiveWired%i_init %s" i crypto_params_receive_init
(*let gen_wired_fun_send_init (cons:string) = Printf.sprintf "sendWired%s_init %s" cons crypto_params_send_init*)

let gen_send_op (cons:string) = Printf.sprintf "sendWired%s" cons
let gen_receive_op (i:node) = Printf.sprintf "receiveWired%i" i

let extract_payload (t:string) = 
    match t with
      | "unit" -> "()"
      | "int" -> "int_of_string(iS (iutf8 raw_payload))"
      | "string" -> "iS (iutf8 raw_payload)"
      | _ -> assert false
let create_payload (t:string) = 
    match t with
      | "unit" -> "(cS \"\")"
      | "int" -> "(cS (string_of_int payl))"
      | "string" -> "(cS payl)" 
      | _ -> assert false
let create_payload2 (t:string) = 
    match t with
      | "unit" -> "(\"\")"
      | "int" -> "((string_of_int payl))"
      | "string" -> "(payl)" 
      | _ -> assert false
let create_payload3 (t:string) = 
    match t with
      | "unit" -> "(\"\")"
      | "int" -> "((string_of_int payload))"
      | "string" -> "(payload)" 
      | _ -> assert false

let rec list_to_string l ra = 
  match l with 
    | [] -> ""
    | [(v1,(c,t))] ->  (Printf.sprintf "(%d,\"%s\")" (List.assoc c ra) c)
    | (v1,(c,t))::r -> (Printf.sprintf "(%d,\"%s\");" (List.assoc c ra) c)^(list_to_string r ra)

let rec list_to_string2 l = 
  match l with 
    | [] -> ""
    | [(v1,(c,t))] ->  (Printf.sprintf "%s "  c)
    | (v1,(c,t))::r -> (Printf.sprintf "%s;"  c)^(list_to_string2 r)

let rec remove_dups ll= 
  let rec isin (a,b) = function [] -> false | (c,d)::l -> (c=a && b=d) || isin (a,b) l in
match ll with
  [] -> []
  | a::l -> if (isin a l) then (remove_dups l) else a::(remove_dups l) 

let crypto_body_send visibility t c n g role_assoc ra = 
  debug (Printf.sprintf "Send: trying to get visibility from node %d, message %s(%s)... " n c t);
  let cl = (visibility n (c,t)) in
(*  debug (Printf.sprintf "got a list of length %d\n" (List.length cl));*)
  let l1 = remove_dups (List.flatten cl) in
  let vision = "["^(list_to_string l1 ra)^"]" in
    debug (Printf.sprintf "Visibility: %s" vision);
  "  match x with \n"^
    "    | "^(gen_wired_cons c)^" (st, payl) ->\n"^
    "      let _ = debug \"Impl\" (\"Preparing message: "^c^"(\"^"^(create_payload2 t)^"^\")\") in\n"^
    "      let header = concat3 (utf8 (cS (string_of_int host))) (utf8 (cS (string_of_int dest))) st.sid in\n"^
    "      let tag = utf8 (cS \""^c^"\") in\n"^
    "      let payload = concat tag (utf8 "^(create_payload t)^") in\n"^
    "      let vision = "^vision^" in\n"^
    "      let (newSt, sigs) = send_label st host dest \""^c^"\"  vision in\n"^
    "      sendMsg newSt host dest header payload sigs; newSt \n"^
    "    | _ -> assert false" 
(*
  "let prepareMsg ("^(gen_wired_cons c)^" (host, dest, localtime, sid, last_sig, payl)) =\n"^
"    let header = concat3 (utf8 (cS (string_of_int host))) (utf8 (cS (string_of_int dest))) sid in\n"^
 "    let tag = utf8 (cS \""^c^"\") in\n"^
 "    let payload = concat tag (utf8 "^(create_payload t)^") in\n"^
 "    let msg = concat header payload in\n"^
"    let vision = "^vision^" in\n"^
"    let (newLast_sig, sigs) = send_label prin_list sid host dest \""^c^"\" last_sig localtime vision in \n"^
"    let plaintext =  concat msg sigs  \n"^
"    in\n"^
"  Printf.printf \"Payload to send: "^c^"(%s)\\n\" "^(create_payload2 t)^";\n"^
"    (base64 plaintext, newLast_sig)\n"^
 "  in\n"^
"  let (msg,newLast_sig) = prepareMsg x in\n"^
"  let principal =   List.nth prin_list host in\n"^
"  let (_,localport) = Prins.get_address (!addrDb) principal in\n"^
"  let destprin = List.nth prin_list dest in\n"^
"  let (destUrl, destPort) =  Prins.get_address (!addrDb) destprin in\n"^
"  let _ = Net.send_udp (localport+50) destUrl destPort (msg) principal in\n"^
 "  newLast_sig"
*)
(*
let crypto_body_send_init t c n g role_assoc ra = 
(*   Printf.printf "Init Send: trying to get visibility from node %d, message %s(%s)\n" n c t;
  let l1 = List.hd (compute_visibility g role_assoc n (c,t)) in
  let vision = "["^(list_to_string l1 ra)^"]" in
    Printf.printf "Visibility: %s\n" vision;*)
  let vision = "[]" in
 "let prepareMsg ("^(gen_wired_cons c)^" (host, dest, localtime, sid, last_sig, payl)) =\n"^
 "    let f s a = concat s (utf8 (cS a)) in\n"^
"    let initial_info = concat3 session (make_principals prin_list) nonce in\n"^
"    let header = concat3 (utf8 (cS (string_of_int host))) (utf8 (cS (string_of_int dest))) initial_info in\n"^

 "    let tag = utf8 (cS \"Message"^c^"\") in\n"^
 "    let payload = concat tag (utf8 "^(create_payload t)^") in\n"^
 "    let msg = concat header payload in\n"^
"    let vision = "^vision^" in\n"^
"    let (newLast_sig,sigs) = send_label prin_list sid host dest \""^c^"\" last_sig localtime vision in \n"^

"    let plaintext = concat msg sigs\n"^

 "    in\n"^
"  Printf.printf \"Payload to send: "^c^"(%s)\\n\" "^(create_payload2 t)^";\n"^
 "    (base64 plaintext, newLast_sig)\n"^
 "  in\n"^
 "  let (msg,newLast_sig) = prepareMsg x in\n"^
 "  let principal =   List.nth prin_list host in\n"^
"  let (_,localport) = Prins.get_address (!addrDb) principal in\n"^
"  let destprin = List.nth prin_list dest in\n"^
"  let (destUrl, destPort) =  Prins.get_address (!addrDb) destprin in\n"^
"  let _ = Net.send_udp (localport+50) destUrl destPort (msg) principal in\n"^
"  newLast_sig"
*)

let rec flat = function []->"" | a::r-> (string_of_int a)^" "^(flat r)

let rec flat2 = function []->"" | (a,b)::r-> (string_of_int a)^" "^(flat2 r)

let gather i na = 
  let rec look_in_domain i na = 
    match na with 
	[] -> []
      | (a,b)::l -> if b=i then a::(look_in_domain i l) else (look_in_domain i l) in
  let rec get_images l =
    let rec gath a na = 
      match na with
	| [] -> []
	| (v,n)::l -> if a=v then n::gath a l else gath a l in
      match l with
	  [] -> []
	| a::ll -> (gath a na)@(get_images ll) in
  let list = look_in_domain i na in
  let ll = get_images list in
    debug (Printf.sprintf "gathered for %d: %s" i (flat ll)); 
    ll

let rec filt l ng = 
  let rec isin a = function [] -> false | b::r -> (a=b) || isin a r in
  let rec remove_dup l  = match l with
    | []->[]
    | a::r -> if isin a r then remove_dup r else a::remove_dup r in
    
  match l with 
      [] -> []
    | a::r -> 
	  begin debug (Printf.sprintf "adding %d " a );
	    remove_dup ((List.assoc a ng)@filt r ng) end

let rec filt2 l ng = 
  let rec isin a = function [] -> false | b::r -> (a=b) || isin a r in
  match ng with 
      [] -> []
    | (a,b)::r -> if (isin a l) then filt2 l r else (a,b)::filt2 l r

let rec rem l ng = 
  let rec isin a  = function [] -> false | b::r -> (a=b) || isin a r in
  match ng with 
      [] -> []
    | (a,ll)::r -> if (isin a l) then (rem l r) else (a::rem l r)
    
let rec find_role_name (s:session) c =
  let rec look_for c rol =
    match rol with
      | [] -> false
      | (s,r)::l ->  if fst s = c then true else look_for_single c r || look_for c l
  and  look_for_single c rol =
    match rol with
      | End n -> false
      | Goto _ -> false
      | Send (n,l) ->  look_for c l
      | Receive (n,l) -> look_for c l
  in
  match s with
    [] -> ""
  | (str,typ,rol)::q ->
     if look_for_single c rol then str else find_role_name q c

let rec find_role_name_recv (s:session) c =
  let rec look_for b c rol =
    match rol with
      | [] -> false
      | (s,r)::l ->  
          if fst s = c 
          then b && true 
          else look_for_action c r || look_for b c l
  and look_for_action c rol =
    match rol with
      | End n -> false
      | Goto _ -> false
      | Send (n,l) ->  look_for false c l
      | Receive (n,l) -> look_for true c l
  in
  match s with
    [] -> ""
  | (str,typ,rol)::q ->
      if look_for_action c rol then str else find_role_name q c

let gen_comment visibility s c g role_assoc ra n t =
  let cl = (visibility n (c,t)) in
  let l1 = remove_dups (List.flatten cl) in
  let vision = (list_to_string2 l1) in
  let role_name = find_role_name s c in
  Printf.sprintf "(* gen_[%s]_%s = sendWired%s ... *)\n(* gensig_%s_%s = sendlabel ... *)\n" vision c c role_name c

let look_for_association i naN = 
  if List.mem_assoc i naN 
  then List.assoc i naN else i

let rec generate_wired_send visibility s (init_nodes:node list) g role_assoc ra naN: graph -> string = function
    [] -> ""
  | (i,(c,t),j)::q -> 
      gen_comment visibility s c g role_assoc ra j t^
      (pretty_expdecl (gen_wired_fun_send c,
                      ArrowT (VarT (gen_wired_type (look_for_association i naN)),VarT "state"),
                      LambdaE ("x",VarT (gen_wired_type (look_for_association i naN)),VarE (crypto_body_send visibility t c j g role_assoc ra))))
      ^"\n"
(*       ^(if List.mem i init_nodes  *)
(*         then (pretty_expdecl (gen_wired_fun_send_init c, *)
(*                              ArrowT (VarT (gen_wired_type i),VarT "bytes list"), *)
(*                              LambdaE ("x",VarT (gen_wired_type i),VarE (crypto_body_send_init t c j g role_assoc ra)))) *)
(*        else "")*)
      ^"\n"^(generate_wired_send visibility s init_nodes g role_assoc ra naN q)

	
let rec create_sum_inputs visibility (n:node) (ng:  (node * graph) list) (g:graph) role_assoc ra na : string  = 
  let rec pp  = function
      [] -> "  | _ -> assert false\n"
    | (_,(c,t),n2)::q -> 
        debug (Printf.sprintf "Recv: trying to get visibility from node %d, message %s of %s" n2 c t);
        let l1 = List.hd (visibility n2 (c,t)) in
        let vision = "["^(list_to_string l1 ra)^"]" in
        let _ = debug (Printf.sprintf "Visibility: %s" vision) in
        "  | \""^c^"\" -> let payload = "^(extract_payload t)
        ^" in\n    let _ = debug \"Impl\" (\"Accepted correct message: "^c^"(\"^"^(create_payload3 t)^"^\")\") "
        ^" in\n    let vision = "^vision
        ^" in\n    let newSt = receive_label st origin host \""^c
        ^"\" sigs vision in\n    "^(gen_wired_cons c)
        ^"(newSt,payload)\n"^ (pp q) 
  in
(*  let rec pp2  = function *)
(*       [] -> ("","") *)
(*     | (_,(c,t),n2)::q ->  *)
(*         let l1 = List.hd (visibility n2 (c,t)) in *)
(*         let vision = "["^(list_to_string2 l1)^"]" in (c,vision) *)
(*  in*)
  match ng with
      [] -> ""
    | (i,l)::q -> 
(*	let (c,vision)= (pp2 (filt (gather i na) ng)) in*)
	  (if i=n then  (*(Printf.sprintf "(* chk_%s_%s *)\n"  vision c)^*)(pp (filt (gather i na) ng)) else "")^(create_sum_inputs visibility n q g role_assoc ra na)
	  
let rec create_sum_inputs_init_recv visibility (n:node) (ng:  (node * graph) list) (g:graph) role_assoc ra na : string  = 
  let rec pp  = function
      [] -> "  | _ -> assert false\n"
    | (_,(c,t),n2)::q -> 
        debug (Printf.sprintf "Init Recv: trying to get visibility from node %d, message %s of %s" n2 c t);
        let l1 = List.hd (visibility n2 (c,t)) in
        let vision = "["^(list_to_string l1 ra)^"]" in
        let _ = debug (Printf.sprintf "Visibility: %s" vision) in
        "  | \""^c^"\" -> let payload = "^(extract_payload t)
        ^" in\n    let _ = debug \"Impl\" (\"Accepted correct message: "^c^"(\"^"^(create_payload3 t)^"^\")\") "
        ^" in\n     let vision = "^vision^" in\n     "
        ^"let newSt = receive_label st origin host \""^c
        ^"\" sigs vision in\n    let _ = debug \"Impl\" \"Checking cache ... \" in\n"
        ^"    (check_cache prin host newSt.sid);    let _ = debug \"Impl\" \"Cache checked!\\n\" in"
        ^"(prin_list ,"^(gen_wired_cons c)
        ^"(newSt, payload))\n"^ (pp q) in
  match ng with
      [] -> ""
    | (i,l)::q -> 
	(if i=n then (pp (filt (gather i na) ng)) else "")^(create_sum_inputs visibility n q g role_assoc ra na) 

let crypto_body_receive visibility n ng g role_assoc ra na=
  "let (tag, host2, dest2, raw_payload, sigs) = receiveMsg host st in\n"^
  "  match tag with\n"^
 (create_sum_inputs visibility n ng g role_assoc ra na)

(*^"\n"^
  "\n"^
 "let checkMsg s = \n"^
"    let ( msg, sigs ) = iconcat (ibase64 s) in \n"^
"    let (header,payload) = iconcat (msg) in \n"^
 "     let (host2, dest2, sid) = iconcat3 header in\n"^
 "      assert (running_sid = sid); \n"^
 "	let (tag,iN) = iconcat payload in\n"^
  "      match  (iS (iutf8 tag)) with\n"^
 (create_sum_inputs n ng g role_assoc ra na)^
  "  in \n"^
"   let principal = List.nth prin_list host in\n"^
"  let (_,localport) = Prins.get_address (!addrDb) principal in \n"^
 "  let t = Net.recv_udp localport  in\n"^
 "  (checkMsg t)"
*)
let crypto_body_receive_init visibility n ng g role_assoc ra na=
  "let (tag, host2, dest2, st, raw_payload, sigs, prin_list) = receiveMsg_init host prin session nb_parties in
    match tag with\n"^
 (create_sum_inputs_init_recv visibility n ng g role_assoc ra na)
(*
 "let checkMsg s = \n"^
"   let ( msg, sigs ) = iconcat (ibase64 s) in \n"^
"    let (header,payload) = iconcat ( msg) in \n"^
 "     let (host2, dest2, sid) = iconcat3 header in\n"^
"    let (session, principals, nonce) = iconcat3 sid in\n"^
"    let prin_list = get_principals principals in\n"^
"    let f s a = concat s (utf8 (cS a)) in\n"^
"      if sha1 sid <> (hashed_info nonce prin_list)\n"^
"      then failwith \"wrong expected session\" else\n"^
"  let (tag, host2, dest2, sid, raw_payload) = receiveMsg host prin_list running_sid in"^
"  match tag with\n"^
 (create_sum_inputs_init_recv n ng g role_assoc ra na)^
  "  in \n"^
 "  let (_,localport) = Prins.get_address (!addrDb) prin in\n"^
 "  let t = Net.recv_udp localport  in\n"^
 "  (checkMsg t)"
*)


let gen_comment_rcv visibility s g role_assoc ra na ng i l=
  let (_,(c,t),_) = List.hd l in
(*
 let rec pp  = function
      [] -> ("","")
    | (_,(c,t),n2)::q ->
        let l1 = List.hd (visibility n2 (c,t)) in
        let vision = "["^(list_to_string2 l1)^"]" in (c,vision)
  in
  let (c,vision)= (pp (filt (gather i na) ng)) in *)
 let role_name = find_role_name_recv s c in
   Printf.sprintf "(* Auxiliary communication function receiveWired%i used by role %s *)\n"  i role_name

let rec generate_wired_receive visibility s (init_nodes:node list) (ng : (node * graph) list  ) g role_assoc ra na : string = 
  match ng with
      [] -> ""
    | (i,l)::q -> 
	gen_comment_rcv visibility s g role_assoc ra na ng i l ^
	(pretty_expdecl (gen_wired_fun_receive i,
			ArrowT (VarT "unit",VarT (gen_wired_type i)),
			LambdaE ("()",VarT "unit",VarE (crypto_body_receive visibility i  ng g role_assoc ra na))))
        ^"\n"
	^(if List.mem i init_nodes 
          then 
	    gen_comment_rcv visibility s g role_assoc ra na ng i l ^
	    (pretty_expdecl (gen_wired_fun_receive_init i,
			       ArrowT (VarT "unit",VarT (gen_wired_type_init_recv i)),
			       LambdaE ("()",VarT "unit",VarE (crypto_body_receive_init visibility i ng g role_assoc ra na))))
          else (""))
        ^(generate_wired_receive visibility s init_nodes (filt2 (gather i na) ng)  g role_assoc ra na)
	  
let add_crypto_fields =  "state * "

let rec generate_wired_type na (ng:(node * graph) list) : string  = match ng with
    [] -> ""
   | (i,l)::q -> 
   debug (Printf.sprintf "ngIn  %s" (flat2 ng));
       debug (Printf.sprintf "trying %d" i);
       (pretty_typedecl 
                    (Sum_type (gen_wired_type i,
                              List.map (fun (_,(c,t),_) -> gen_wired_cons c,VarT (add_crypto_fields^t)) (filt (gather i na) ng)))^
      (generate_wired_type na (filt2 (gather i na) ng)))

(*let rec generate_wired_type na : (node * graph) list -> string  = function
    [] -> ""
   | (i,l)::q -> (pretty_typedecl 
                    (Sum_type (gen_wired_type i,
                              List.map (fun (_,(c,t),_) -> gen_wired_cons c,VarT (add_crypto_fields^t)) (gather i l na))))^
      (generate_wired_type q)
*)
let generate_wired visibility s (g:graph) (init_nodes:node list) role_assoc ra na naN = 
  let ng = sort_by_send g in
    debug (Printf.sprintf "ng  %s" (flat2 ng));
  "\n(* Wired types, send and receive functions *)\n\n"^
  (generate_wired_type na ng)^"\n\n"^(generate_wired_send visibility s init_nodes g role_assoc ra naN g)^(generate_wired_receive visibility s init_nodes ng g role_assoc ra na)

  (* Two steps:
     1. We generate for each receiving node a sum-type and 
        a specific receive function.
     2. For each edge we generate a send function
  *)  


(********************************************)
(*              Flow types                  *)
(********************************************)

(* Triggers some differences between sending and receiving messages *)
type direction = bool
let sendDirection : direction = true
let receiveDirection : direction = false

let gen_result_type (role:string) = Printf.sprintf "result_%s" role
let gen_typename (n:node) = Printf.sprintf "msg%d" n
let gen_cons_name (cons:string) = Printf.sprintf "%s" cons
let gen_handler_label (cons:string) = Printf.sprintf "h%s" cons

let gen_constructor (d: direction) : message -> string = 
  function (consname,typ) ->
    if d = sendDirection 
    then Printf.sprintf " %s of (%s" (gen_cons_name consname) typ
    else Printf.sprintf "   %s : (principals -> %s" (gen_handler_label consname) typ

let rec gen_sumtype (d: direction) (role:string) : (message * role_type) list -> string = function 
    [] -> ""
  | [m,Goto n] -> 
      (gen_constructor d m)^
        (if d= sendDirection then " * " else " -> ")^
        (gen_typename n)^
        (if d= sendDirection then ")\n" else ")}\n")
  | [m,End _] -> 
      (gen_constructor d m)^
        (if d= sendDirection then " * " else " -> ")^
        (gen_result_type role)^")"^(if d= sendDirection then "\n" else "}\n")
  | [_,_] -> assert false
  | (m,Goto n)::q -> 
      (gen_constructor d m)^
	(if d= sendDirection then " * " else " -> ")^
	(gen_typename n)^
	(if d= sendDirection then ")\n |" else ") ;\n")^
	(gen_sumtype d role q)
  | (m,End _)::q -> 
      (gen_constructor d m)^
	(if d= sendDirection then " * " else " -> ")^
        (gen_result_type role)^
	(if d= sendDirection then ")\n |" else ") ;\n")^
	(gen_sumtype d role q)
  | _ -> assert false

let gen_decl (na:(node*node) list) (role:string) : role_type -> string = function
    End _ -> assert false
  | Goto _ -> assert false
  | Send (n,l) -> (gen_typename n)^" = \n  "^(gen_sumtype sendDirection role l )
  | Receive (n,l) -> 
 (*     let n = alias na n in *)
      (gen_typename n)^" = {\n"^(gen_sumtype receiveDirection role l )

let rec gen_types (na:(node*node) list) (role:string) : role_type list -> string = function
    [] -> ""
  | [r] -> "\ntype "^(gen_decl na role r)
  | r::q -> (gen_types na role q)^"and "^(gen_decl na role r)




(********************************************)
(*           Proxy generation               *)
(********************************************)

(* String generation *)
let gen_handler_name s = Printf.sprintf "handlers.h%s newSt.prins " s
let gen_handler_name_recv s = Printf.sprintf "handlers.h%s (unprin st.prins) " s

(* Pretty printing functions *)
let rec gen_rec_fun : (string*string) list -> string = function
    [] -> ""
  | [(s1,s2)] -> Printf.sprintf "(* %s *)\nlet rec %s" s1 s2
  | (s1,s2)::q -> (gen_rec_fun q)^"(* "^s1^" *)\nand "^s2

(* Sending operations *)
let crypto_params = " (st:state)"
let crypto_params_recv = " (st:state)"
(*let crypto_params_init_send = " nonce (last_sig:bytes list)"*)
let crypto_params_init_recv = ""
let crypto_params_init_recv2 = ""
let crypto_params2 = "host dest"
(*let crypto_params2_init_send = "host dest prin_list nonce"*)
let crypto_params3_recv = "newSt"
let crypto_params3 = "newSt"

(*let gen_ops_send_init (role_assoc:(string*int) list) (role:string) (n:node) (cons_name:string) (i:node) (initiator:bool)= 
  Printf.sprintf "  | %s(x,next) ->\n    let sid = hashed_info nonce prin_list in\n    let dest = %d in\n    let newLast_sig = %s_init %s (%s (%s,x)) in\n    %s_%s %s next\n"
    (gen_cons_name cons_name) 
    (List.assoc cons_name role_assoc)
    (gen_send_op cons_name)
    (crypto_params2_init_send)
    (gen_wired_cons cons_name)
    (crypto_material2)
    role
    (gen_typename i)
    (if initiator then (crypto_params3) else (crypto_params3_recv))

let rec gen_fun_send_init (role_assoc:(string*int) list) (role:string) (n:node) (initiator:bool): (message * role_type) list -> string =
  function
      [] -> assert false
    | [(cons_name,_),End _] -> 
	Printf.sprintf "  | %s(x,res) ->\n     let sid = hashed_info nonce prin_list in\n    let dest = %d in\n    let newLast_sig = %s_init %s (%s (%s,x)) in\n    res\n" 
	  (gen_cons_name cons_name) 
          (List.assoc cons_name role_assoc)
	  (gen_send_op cons_name)
	  (crypto_params2_init_send)
	  (gen_wired_cons cons_name)
	  (crypto_material2)
    | [(cons_name,_),Goto i] -> gen_ops_send_init role_assoc role n cons_name i initiator
    | [(cons_name,_),Send (i,_)] -> gen_ops_send_init role_assoc role n cons_name i initiator
    | [(cons_name,_),Receive (i,_)] -> gen_ops_send_init role_assoc role n cons_name i initiator
    | ((cons_name,_),End _)::q -> 
	(Printf.sprintf "  | %s(x,res) ->\n    let dest = %d in\n    let newLast_sig = %s_init %s (%s (%s,x)) in\n    res\n"  
	    (gen_cons_name cons_name)  
            (List.assoc cons_name role_assoc)
	    (gen_send_op cons_name)
	    (crypto_params2)
	    (gen_wired_cons cons_name)
	    (crypto_material2)
	)^
	  (gen_fun_send_init role_assoc role n initiator q)
    | ((cons_name,_),Goto i)::q -> (gen_ops_send_init role_assoc role n cons_name i initiator)^(gen_fun_send_init role_assoc role n initiator q)
    | ((cons_name,_),Send (i,_))::q -> (gen_ops_send_init role_assoc role n cons_name i initiator)^(gen_fun_send_init role_assoc role n initiator q)
    | ((cons_name,_),Receive (i,_))::q -> (gen_ops_send_init role_assoc role n cons_name i initiator)^(gen_fun_send_init role_assoc role n initiator q)
*)
let gen_ops_send (role_assoc:(string*int) list) (role:string) (n:node) (cons_name:string) (i:node) (initiator:bool)= 
  Printf.sprintf "  | %s(x,next) ->\n     let dest = %d in\n    let newSt = %s host dest (%s(st, x)) in\n    %s_%s %s next\n"
    (gen_cons_name cons_name) 
    (List.assoc cons_name role_assoc) 
    (gen_send_op cons_name)
    (gen_wired_cons cons_name)
    role
    (gen_typename i)
     (if initiator then (crypto_params3) else (crypto_params3_recv))

let rec gen_fun_send (role_assoc:(string*int) list) (role:string) (n:node) (initiator:bool) : (message * role_type) list -> string =
  function
      [] -> assert false
    | [(cons_name,_),End _] -> 
	Printf.sprintf "  | %s(x,res) ->\n    let dest = %d in\n    let _ (*newSt*) = %s host dest (%s(st, x)) in\n    res\n" 
	  (gen_cons_name cons_name) 
          (List.assoc cons_name role_assoc)
	  (gen_send_op cons_name)
	  (gen_wired_cons cons_name)
    | [(cons_name,_),Goto i] -> gen_ops_send role_assoc role n cons_name i initiator
    | [(cons_name,_),Send (i,_)] -> gen_ops_send role_assoc role n cons_name i initiator
    | [(cons_name,_),Receive (i,_)] -> gen_ops_send role_assoc role n cons_name i initiator
    | ((cons_name,_),End _)::q -> 
	(Printf.sprintf "  | %s(x,res) ->\n    let dest = %d in\n    let _ (*newSt*) = %s host dest (%s(st, x)) in\n    res\n"  
	    (gen_cons_name cons_name) 
            (List.assoc cons_name role_assoc) 
	    (gen_send_op cons_name)
	    (gen_wired_cons cons_name)
	)^
	  (gen_fun_send role_assoc role n initiator q)
    | ((cons_name,_),Goto i)::q -> (gen_ops_send role_assoc role n cons_name i initiator)^(gen_fun_send role_assoc role n initiator q)
    | ((cons_name,_),Send (i,_))::q -> (gen_ops_send role_assoc role n cons_name i initiator)^(gen_fun_send role_assoc role n initiator q)
    | ((cons_name,_),Receive (i,_))::q -> (gen_ops_send role_assoc role n cons_name i initiator)^(gen_fun_send role_assoc role n initiator q)

(* Receive operations *)
let rec gen_handler_receive : (message * role_type) list -> string = 
  function
      [] -> assert false
    | [(cons_name,_),_] -> Printf.sprintf "%s" (gen_handler_name cons_name)
    | ((cons_name,_),_)::q -> (Printf.sprintf "%s, " (gen_handler_name cons_name))^(gen_handler_receive q)

let gen_ops_receive (role:string) (cons_name:string) (i:node)  (initiator:bool)  = 
  Printf.sprintf "    | %s (newSt, x) ->\n    let next = %s x in\n    %s_%s %s next\n"
    (gen_wired_cons cons_name)
    (gen_handler_name cons_name)
    role
    (gen_typename i)
   (*(if initiator then (crypto_params3) else (crypto_params3_recv))*)
    crypto_params3

let rec gen_fun_receive (role:string) initiator : (message * role_type) list -> string =
  function
      [] -> assert false
    | [(cons_name,_),End _] -> 
	Printf.sprintf "    | %s(newSt, x) ->\n    let next = %s x in\n    next\n" 
	  (gen_wired_cons cons_name)
	  (gen_handler_name cons_name) 
    | [(cons_name,_),Goto i] -> gen_ops_receive role cons_name i initiator
    | [(cons_name,_),Send (i,_)] -> gen_ops_receive role cons_name i initiator
    | [(cons_name,_),Receive (i,_)] -> gen_ops_receive role cons_name i initiator
    | ((cons_name,_),End _)::q -> 
	(Printf.sprintf "    | %s(newSt, x) ->\n    let next = %s x in\n    next\n" 
	    (gen_wired_cons cons_name)
	    (gen_handler_name cons_name))^
	  (gen_fun_receive role initiator q)
    | ((cons_name,_),Goto i)::q -> (gen_ops_receive role cons_name i initiator)^(gen_fun_receive role initiator q)
    | ((cons_name,_),Send (i,_))::q -> (gen_ops_receive role cons_name i initiator)^(gen_fun_receive role initiator q)
    | ((cons_name,_),Receive (i,_))::q -> (gen_ops_receive role cons_name i initiator)^(gen_fun_receive role initiator q)

let crypto_wired = "origin host st"
let crypto_wired_init_recv = "origin host prin "

(*------------------*)
(* Proxy generation *)

let rec gen_aux (na:(node*node) list) (role_assoc:(string*int) list) (role_assoc_O:(string*int) list)  (role:string) (initiator:bool)= function 
  | End _ -> assert false
  | Goto _ -> assert false
  | Send (n,l) -> 
      let fun_name = 
        Printf.sprintf "%s_%s %s : %s -> %s = function\n" 
          role 
          (gen_typename n) 
          (if initiator then crypto_params else crypto_params_recv)
          (gen_typename n) 
          (gen_result_type role) in
      ("header sending", fun_name^(gen_fun_send role_assoc role n initiator l))
  | Receive (n,l) -> 
      let nreceive = alias na n in
      let fun_name = 
        Printf.sprintf "%s_%s %s : %s -> %s = function handlers ->\n" 
          role 
          (gen_typename n) 
          (if initiator then crypto_params else crypto_params_recv)
          (gen_typename n) 
          (gen_result_type role) in
      ("header receiving", 
		     Printf.sprintf "%s  let origin = %i in\n  let r = %s %s () in\n    match r with\n%s" 
		     fun_name
                     (List.assoc (fst (fst (List.hd l))) role_assoc_O)
                     (gen_receive_op nreceive)
		     (crypto_wired)
		     (gen_fun_receive role initiator l))

let rec gen_aux_init (na:(node*node) list) (role_assoc:(string*int) list) (role_assoc_O:(string*int) list) (role:string) (initiator:bool) = function 
  | End _ -> assert false
  | Goto _ -> assert false
  | Send (n,l) -> 
(*      let fun_name = 
        Printf.sprintf "%s_%s_init %s : %s -> %s = function\n" role (gen_typename n) crypto_params_init_send (gen_typename n) (gen_result_type role) in
	fun_name^(gen_fun_send_init role_assoc role n initiator l) *) ("","")
  | Receive (n,l) -> 
      let nreceive = alias na n in
      let fun_name = 
		     Printf.sprintf "%s_%s_init %s : %s -> %s = function handlers ->\n" role (gen_typename n) (if initiator then crypto_params_init_recv else crypto_params_init_recv2) (gen_typename n) (gen_result_type role) in
	("recv init", Printf.sprintf "%s  let origin = %i in\n  let (newSt, r) = %s_init %s () in\n    match r with\n%s" 
		     fun_name
                     (List.assoc (fst (fst (List.hd l))) role_assoc_O)
		     (gen_receive_op nreceive)
		     (crypto_wired_init_recv)
		     (gen_fun_receive role initiator l))

let proxy_functions (na:(node*node) list) (role_assoc:(string*int) list) (role_assoc_O:(string*int) list) (role:string) (l:role_type list) (initiator:bool) : (string*string) list =
  if initiator then (List.map (gen_aux na role_assoc role_assoc_O role initiator) l) else
  ((gen_aux_init na role_assoc role_assoc_O role initiator (List.hd l))
  ::(List.map (gen_aux na role_assoc role_assoc_O role initiator) l))

(*----------------------*)
(* First and last lines *)

let gen_user_inputs (l:role_type list) : string =
  match l with
      [] -> assert false
    | (Send (n,_ ))::_-> Printf.sprintf "(user_input : %s) " ((gen_typename n))
    | (Receive (n,_))::_-> Printf.sprintf "(user_input : %s) " ((gen_typename n))
    | _ -> assert false

let gen_user_inputs_i (l:role_type list) : string =
  match l with
      [] -> assert false
    | (Send (n,_ ))::_-> Printf.sprintf " %s ->" ((gen_typename n))
    | (Receive (n,_))::_-> Printf.sprintf " %s ->" ((gen_typename n))
    | _ -> assert false

let crypto_first_line = " (prins: principals) "
let crypto_first_line_recv = " (prin: principal) "

let crypto_first_line_i = ": principals ->"
let crypto_first_line_recv_i = ": principal ->"

let first_line (l:role_type list) = crypto_first_line^(gen_user_inputs l)
let first_line_recv (l:role_type list) = crypto_first_line_recv^gen_user_inputs l

let first_line_i (l:role_type list) = crypto_first_line_i^(gen_user_inputs_i l)
let first_line_recv_i (l:role_type list) = crypto_first_line_recv_i^gen_user_inputs_i l
  
let crypto_last_line c= " let prin = (List.nth (genprin prins) host) in\n debug \"Impl\" (\"Executing role "^c^" with principal \"^prin^\"...\") ; bind prin;\n  let result = "
let crypto_last_line_recv c= "  debug \"Impl\" (\"Executing role "^c^" with principal \"^prin^\"...\");\n bind prin; let result = "
let crypto_last_params = "(create_fresh_state prins)"

let last_line (role:string) (l:role_type list) = 
  match List.hd l (*filter_node 0 l *) with
    | Send (i,lm) ->
	(Printf.sprintf "%s %s_%s %s user_input in close(); result\n"
	    (crypto_last_line role)
	    role
	    (gen_typename i)
	    (crypto_last_params))
    | Receive (i,_) ->
	(Printf.sprintf "%s %s_%s_init user_input in close(); result\n" 
	    (crypto_last_line_recv role)
	    role
	    (gen_typename i))
    | _ -> assert false

(*------------------------------*)
let first_send r = 
  match r with
    | Send (_,_) -> true
    | _ -> false 

let rec toto i = function
    [] -> []
  | (name,_,_)::q -> (name,i)::toto (i+1) q


let let_dest rolen = (Printf.sprintf "let host = %d in" rolen)
(* Function generation complete *)

let generate_functions (na:(node*node) list) (role_assoc:(string*int) list) (role_assoc_O:(string*int) list)
    (role:string) (r : role_type list) (original_role:role_type) (rolen:int)  = 
  let initiator = (first_send original_role) in
  Printf.sprintf "let %s %s =\n%s\n%sin\n%s"
    role
    (if initiator then
	(begin debug (Printf.sprintf "%s is initiator" role) end; (first_line r) )
      else 
	(begin debug (Printf.sprintf "%s is not initiator" role) end; 
	first_line_recv r))
    (let_dest rolen)
    (gen_rec_fun (proxy_functions na role_assoc role_assoc_O role r initiator ))
    (last_line role r)

let generate_functions_i (na:(node*node) list) (role_assoc:(string*int) list) (role:string) (r : role_type list) (original_role:role_type) (rolen:int) (*: string list *) =
let initiator = (first_send original_role) in
  Printf.sprintf "val %s %s result_%s\n"
    role
    (if initiator then
	(debug (Printf.sprintf "%s is initiator" role) ; first_line_i r)
      else 
	(debug (Printf.sprintf "%s is not initiator" role); first_line_recv_i r))
    role

(********************************************)
(*           Complete generation            *)
(********************************************)

let generate_from_role (na:(node*node) list) (role_assoc:(string*int) list) (role_assoc_O:(string*int) list) (role_name:string) (typ:string) (role:role_type) (rolen:int)= 
  let flatten_session = flatten role in
  (Printf.sprintf "\n(* Proxy function for %s *)\n" role_name)^
  (Printf.sprintf "\ntype %s = %s\n" (gen_result_type role_name) typ)^
  (gen_types na role_name (List.rev flatten_session))^"\n"^
    (generate_functions na role_assoc role_assoc_O role_name flatten_session role rolen)
      
let rec generate_from_session (s:session) (na:(node*node) list) (role_assoc:(string*int) list) (role_assoc_O:(string*int) list) i = 
  match s with
    [] -> []
  | (str,typ,rol)::q -> 
      debug (Printf.sprintf "host n. for %s is %d" str i);
      (generate_from_role na role_assoc role_assoc_O str typ rol i)::(generate_from_session q na role_assoc role_assoc_O (i+1))

let generate_from_role_i (na:(node*node) list) (role_assoc:(string*int) list) (role_name:string) (typ:string) (role:role_type) (rolen:int)= 
  let flatten_session = flatten role in
  (Printf.sprintf "\n(* Proxy function for %s *)\n" role_name)^
  (Printf.sprintf "\ntype %s = %s\n" (gen_result_type role_name) typ)^
  (gen_types na role_name (List.rev flatten_session))^"\n"^
    (generate_functions_i na role_assoc role_name flatten_session role rolen)
      
let rec generate_from_session_i (s:session) (na:(node*node) list) (role_assoc:(string*int) list) i = 
  match s with
    [] -> []
  | (str,typ,rol)::q -> 
      debug (Printf.sprintf "host n. for %s is %d" str i);
      (generate_from_role_i na role_assoc str typ rol i)::(generate_from_session_i q na role_assoc (i+1))


let rec role_number (i:int) = function
    [] -> []
  | (r,_,_)::q -> (r,i)::(role_number (i+1) q)

let rec create_principals_record t= function
    [] -> assert false
  | [(r,_,_)] -> Printf.sprintf "%s:%s" r t
  | (r,_,_)::q -> (Printf.sprintf "%s:%s; " r t)^create_principals_record t q

let rec principals_record = function
    [] -> assert false
  | [(r,_,_)] -> Printf.sprintf "prin_list.%s ]" r
  | (r,_,_)::q -> (Printf.sprintf "prin_list.%s; " r)^principals_record q

let rec principals_record2 i= function
    [] -> assert false
  | [(r,_,_)] -> Printf.sprintf "%s=List.nth prin_list %i }" r i
  | (r,_,_)::q -> (Printf.sprintf "%s=List.nth prin_list %i; " r i)^principals_record2 (i+1) q


let rec sigs_record role = function
    [] -> "  | _ -> assert false\n"
  | (r,_,_)::q -> (Printf.sprintf "  | %d -> sigs.%s\n" role r)^ sigs_record (role+1) q


let rec empty_sigs_record = function
    [] -> assert false
  | [(r,_,_)] -> Printf.sprintf "%s = {tstime=0; tsval=utf8 (cS \"\")} }" r
  | (r,_,_)::q -> (Printf.sprintf "%s = {tstime=0; tsval=utf8 (cS \"\")}; " r)^empty_sigs_record q

let rec genupd role = function
    [] -> "  | _ -> assert false\n"
  | (r,_,_)::q -> (Printf.sprintf "  | %d -> st.sigs.%s.tsval <- newsig; st.sigs.%s.tstime <- newtime; st\n" role r r)^ genupd (role+1) q


let gen_prins s =  
"type principal = string\ntype principals_list = principal list
type principals = {"^(create_principals_record "principal" s)^"}

(* The internal representation is a list, so we provide translation functions.*)
let genprin prin_list = ["^principals_record s^"
let unprin prin_list = {"^principals_record2 0 s^"

(* State definitions.*)
type tsig = { mutable tstime : int; mutable tsval : bytes }
type tsigs = { "^(create_principals_record "tsig" s)^"}
type state = { sid : bytes; prins : principals; nonce:bytes; mutable time:int; sigs : tsigs }

let make_principals (principals:principal list) (nb_parties:int)= 
  let rec icc p acc = 
  match p with 
    | [] -> acc
    | a::rest -> let newacc = concat acc (utf8 (cS a)) in icc rest newacc in
  let start = utf8 (cS (List.hd principals)) in
  icc (List.tl principals) start

let make_signature (principal:string) (label:string) (sid:bytes) (time:int) : bytes = 
  let signk = get_privkey (cS principal) in 
  let msg = concat3 sid (utf8 (cS label)) (utf8 (cS (string_of_int time))) in 
  rsa_sign signk msg

let getsig sigs role = match role with\n"^sigs_record 0 s^"
let populate_emptysigs = {"^empty_sigs_record s^"

let create_fresh_state prins = 
  let nonce = mkNonce () in  
  let sid = concat3 session (make_principals (genprin prins) nb_parties) nonce  in
  {sid=sid; prins=prins; nonce=nonce; time=0; sigs=populate_emptysigs}

let update_signature (st:state) (role:int) (newsig:bytes) (newtime:int) = 
  match role with 
"^(genupd 0 s)^"
let send_label (st:state) (role:int) (dest:int) (label:string)(vision: (int * string) list)= 
  let principal = List.nth (genprin st.prins) role in
  let fetch_signature  (rest:bytes) ((role:int) , (label:string)):  bytes =
    let thesig = (getsig st.sigs role) in
    concat3 (utf8 (cS (string_of_int thesig.tstime))) thesig.tsval rest in
  let l = if List.length vision > 1 then List.tl vision else vision in
  let msg = (List.fold_left fetch_signature (utf8 (cS \"\"))) l in 
  let localsig = make_signature principal label st.sid st.time in
  let newSt = update_signature st role localsig st.time in
  let sigs = concat3 (utf8 (cS (string_of_int st.time))) localsig msg in
  (newSt, sigs)

let sendMsg (st:state) (host:int) (dest:int) header payload sigs =
  let msg =  concat3 header payload sigs in
  let destprin = List.nth (genprin st.prins) dest in
  let _ = psend destprin (base64 msg) in
  ()

let receiveMsg (host:int) (st:state) = 
  let principal = List.nth (genprin st.prins) host in
  let s  = precv principal in
  let (header,payload,sigs) = iconcat3 (ibase64 s) in
  let (host2, dest2, sid) = iconcat3 header in
  assert (st.sid = sid);
  let (raw_tag,iN) = iconcat payload in
  let tag = (iS (iutf8 raw_tag)) in
  (tag, int_of_string (iS (iutf8 host2)), int_of_string (iS (iutf8 dest2)), iN, sigs)

let get_principals  (principals:bytes) (nb_parties:int) = 
  let rec rev = function [] -> [] | a::l -> (rev l)@[a] in
  let rec icc p count = 
    if count=1 then 
       [iS (iutf8 p)]
    else 
      let (a,rest) = iconcat p in
      let ab = iS (iutf8 rest) in
	ab::(icc a (count-1)) in
    rev(icc principals nb_parties)

let check_signature (principal:string) (label:string) (sid:bytes) (time:int) (signature:bytes) (role:int) : unit = 
  let pubk = get_pubkey (cS principal) in
  let msg = concat3 sid (utf8 (cS label)) (utf8 (cS (string_of_int time))) in
    rsa_verify pubk msg signature

let hashed_info session_hashed (nonce:bytes) prin_list = 
  sha1 (concat3 session_hashed (make_principals prin_list (List.length prin_list)) nonce)

let receiveMsg_init (host:int) (prin:principal) session_hashed nb_parties = 
    let s = precv prin in
    let (header,payload, sigs) = iconcat3 (ibase64 s) in
    let (host2, dest2, sid) = iconcat3 header in
    let (session_hashed, principals, nonce) = iconcat3 sid in
    let prin_list = get_principals principals nb_parties in
    if sha1 sid <> (hashed_info session_hashed nonce prin_list)
    then failwith \"wrong expected session\"
    else
      let (raw_tag,iN) = iconcat payload in
      let tag = (iS (iutf8 raw_tag)) in
        (tag, int_of_string (iS (iutf8 host2)), int_of_string (iS (iutf8 dest2)), 
        {sid=sid; prins=unprin prin_list; nonce=nonce; time=0; sigs=populate_emptysigs}
        , iN, sigs, prin_list)

let receive_label st (origin:int) (role:int) (label:string) (msg:bytes) (vision: (int * string) list) = 
  let principal = List.nth (genprin st.prins) origin in
  let check_visible  ((time:int), (rest:bytes))((role:int) , (label:string)): (int * bytes) =
    let bt',sv,rest = iconcat3 rest in
    let t' = int_of_string (iS (iutf8 bt')) in
         assert ((int_of_string (iS (iutf8 bt'))) >= st.time);
         let principal = List.nth (genprin st.prins) role in
         check_signature principal label st.sid t' sv role;
         (if time < t' then (t', rest) else (time,rest)) in
  let update_sigs (st,(rest:bytes)) ((role:int) , (label:string))  = 
       let bt',sv,rest = iconcat3 rest in
       ((update_signature st role sv (int_of_string (iS (iutf8 bt')))),rest) in
  let _ = debug \"Impl\" \"Updating signatures ... \" in 
  let (new_localtime,rest) = (List.fold_left check_visible (st.time,msg) vision) in 
  st.time <- new_localtime+1; (* update local time with the newest time plus one *)
  let (newSt,rest) = (List.fold_left update_sigs (st,msg) vision) in 
  let _ = debug \"Impl\"  \"Signatures updated!\" in 
  newSt\n"

let gen_prins_i s = 
"(* Generated Session Interface *)\n
open Data\n
type principal=string
type principals= {"^(create_principals_record "principal" s)^"}\n"


let generate_code (s:session) =
  let g,na = graph_from_session s in
  let naN = normalize na in
  let role_assoc = assoc_from_session s in
  let visibility = compute_visibility g role_assoc in
  let rn = role_number 0 s in
  let rec create_msg2role = function
      [] -> []
    | (i,(c,p),j)::q -> (c,List.assoc (List.assoc j role_assoc) rn)::(create_msg2role q) in
  let rec create_msg2roleOrigin = function
      [] -> []
    | (i,(c,p),j)::q -> (c,List.assoc (List.assoc i role_assoc) rn)::(create_msg2roleOrigin q) in
  let ra = create_msg2role g in
  let raO = create_msg2roleOrigin g in
  let init_nodes = List.map (fun (_,_,rol) -> alias na (node_of rol)) s in
    ((global_def g (List.length s))
      ::(gen_prins s)
      ::(generate_wired visibility s g init_nodes role_assoc raO na naN) 
      ::(generate_from_session s na ra raO 0),(g,role_assoc))
  
let global_def_i s = gen_prins_i s

let generate_interface (s:session) =
  let g,na = graph_from_session s in
  let role_assoc = assoc_from_session s in
  let rn = role_number 0 s in
  let rec create_msg2role = function
      [] -> []
    | (i,(c,p),j)::q -> (c,List.assoc (List.assoc j role_assoc) rn)::(create_msg2role q) in
  let rec create_msg2roleOrigin = function
      [] -> []
    | (i,(c,p),j)::q -> (c,List.assoc (List.assoc i role_assoc) rn)::(create_msg2roleOrigin q) in
  let ra = create_msg2role g in
  (global_def_i s)::(generate_from_session_i s na ra 0)
